#include<iostream>
#include<assert.h>
#include"ezwin.h"
#include"bitmap.h"
float tank1x=3.25,tank2x=24.25,tankx=tank1x;
int counter_tank=1;

void delay(unsigned long ms)
    {
    usleep(ms*1000);
    }

SimpleWindow anywindow("ptanks", 28.0, 21.0, Position(0.0, 0.0));

float f(float m,int a,float x){
	float y=x<14?a-m*x:a-m*(28-x);
return y;
}

float terrainshape(float x, float a[]){
	int temp; float y;
	temp=2*x;
	y=a[temp]+(2*x-temp)*(a[temp+1]-a[temp]);
	return y;
}

void drawtank(float xpos, color c, float trnnet[]){
float bottomlevel;
bottomlevel=terrainshape(xpos,trnnet);
anywindow.RenderRectangle(Position(xpos-0.5,bottomlevel-0.7),Position(xpos+0.5,bottomlevel),c,false);
}


void editterrain(float xblast,float yblast,float blastrange,float trnnet[], Position trnpts[]){
float fi; float yc;
for(int i=1+2*(xblast-blastrange);i<=2*(xblast+blastrange);i++){
fi=i;
yc=sqrt(blastrange*blastrange-(xblast-fi/2)*(xblast-fi/2));
if(trnnet[i]<=yblast-yc){
trnnet[i]+=2*yc;
}
else {
if(trnnet[i]>=yblast+yc){trnnet[i]=trnnet[i];
} else {trnnet[i]=yblast+yc;}
}
trnpts[i]=Position(fi/2,trnnet[i]);
}
anywindow.RenderPolygon(trnpts,59,Green,false);
drawtank(tank1x, Blue, trnnet);
drawtank(tank2x, Black, trnnet);
}

void Wall(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	for(float t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-0.5){break;}
		delay(10);
	}
	nuke.Erase();

	int wall_centre; float float_i;
	wall_centre=2*x;
	wall_centre=2*x-wall_centre>0.5?wall_centre+1:wall_centre;
	for(float t=0;t<2;t+=0.1){
		trnnet[wall_centre]-=0.3;
		for(int i=wall_centre-1;i<=wall_centre+1;i++){
			float_i=i;
			trnnet[i]=trnnet[wall_centre];
			trnpts[i]=Position(float_i/2,trnnet[i]);
		}
		anywindow.RenderPolygon(trnpts,59,Green,false);
		delay(100);
	}
	counter_tank++;
}


void Meteor_shower(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,t,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	BitMap meteor(anywindow);
	meteor.Load("meteor.xpm");
	theta=phi*3.141592/180;
	for(t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-0.3){break;}
		delay(10);
	}
	nuke.Erase();
	int i=0; float temp=x;
	while(i<5){
		x_fp=temp-1+.1*(rand()%21);
		for(t=0;t<10000;t+=0.05){
		meteor.Erase();
		x=x_fp+.5*.02*wind*t*t;
		y=2*t+2*t*t;
		Position meteorposition=Position(x,y);
		meteor.SetPosition(meteorposition);
		meteor.Draw();
		if(y>=terrainshape(x,trnnet)-0.5){break;}
		delay(50);
		}
		for(float i1=0.1; i1<1.5; i1+=0.1){
		if(i1<.8)
			anywindow.RenderEllipse(Position(x-i1,y-i1),Position(x+i1,y+i1),Red,false);
		if(i1>.7)
		  anywindow.RenderEllipse(Position(x-i1+.7,y-i1+.7),Position(x+i1-.7,y+i1-.7),White,false);
		delay(100);
		}
		anywindow.RenderPolygon(trnpts,59,White,false);
		editterrain(x,terrainshape(x,trnnet),.6,trnnet,trnpts);
		i++;
	}
	counter_tank++;
}


void Nuke(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	for(float t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)){break;}
		delay(10);
	}

	for(float i=0.1; i<4.9; i+=0.1){
	if(i<2.5)
		anywindow.RenderEllipse(Position(x-i,y-i),Position(x+i,y+i),Red,false);
	if(i>0.6 && i<3.1) 
		anywindow.RenderEllipse(Position(x-i+0.6,y-i+0.6),Position(x+i-0.6,y+i-0.6),Yellow,false);
	if(i>1.2 && i<3.7)
		anywindow.RenderEllipse(Position(x-i+1.2,y-i+1.2),Position(x+i-1.2,y+i-1.2),Red,false);
	if(i>1.8 && i<4.3)
		anywindow.RenderEllipse(Position(x-i+1.8,y-i+1.8),Position(x+i-1.8,y+i-1.8),Yellow,false);
	if(i>2.4)
	  anywindow.RenderEllipse(Position(x-i+2.4,y-i+2.4),Position(x+i-2.4,y+i-2.4),White,false);
	delay(50);
	}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,y,2.4,trnnet,trnpts);
	counter_tank++;
}


void Zapper(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	float tank2y=terrainshape(tank2x,trnnet);
	theta=phi*3.141592/180;
	for(float t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet) || sqrt((x-tank2x)*(x-tank2x)+(y-tank2y)*(y-tank2y))<1.5){break;}
		delay(10);
	}
	if(y>=terrainshape(x,trnnet)){
		for(float i=0.1; i<2.1; i+=0.1){
		if(i<1.1)
			anywindow.RenderEllipse(Position(x-i,y-i),Position(x+i,y+i),Red,false);
		if(i>1.0)
		  anywindow.RenderEllipse(Position(x-i+1,y-i+1),Position(x+i-1,y+i-1),White,false);
		delay(50);
		}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,y,1,trnnet,trnpts);
	}
	else{
		for(int i=0; i<14; i++){
		color c=i%2==0?Red:White;
		anywindow.RenderLine(Position(x,y),Position(tank2x,tank2y),c,0.05);
		delay(100);
		}
	nuke.Erase();
	}
}


void Skipper(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,theta,xvel,yvel;
	float a,b,p,q,e=-0.4; int temp, j=0;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	xvel=0.15*power*cos(theta); yvel=-0.15*power*sin(theta);

	float t;
	while(j<5){
		for(t=0;1;t+=0.01){
			nuke.Erase();
			x=x_fp+xvel*t+0.5*.02*wind*t*t;
			y=y_fp+yvel*t+2*t*t;
			nukeposition=Position(x,y);
			nuke.SetPosition(nukeposition);
			nuke.Draw();
			if(y>=terrainshape(x,trnnet)-0.1){break;}
			delay(10);
		}
		if(x<=0 || x>28){break;}
		temp=2*x;
		p=0.5; q=trnnet[temp+1]-trnnet[temp];
		a=xvel+.02*wind*t; b=yvel+4*t;
		xvel=(a*(p*p+e*q*q)+(1-e)*b*p*q)/(p*p+q*q);
		yvel=(b*(e*p*p+q*q)+(1-e)*a*p*q)/(p*p+q*q);
		x_fp=x;
		y_fp=y-0.2;
		j++;
	}
	if(x>0 && x<28){
	for(float i=0.1; i<2.5; i+=0.1){
	if(i<1.3)
		anywindow.RenderEllipse(Position(x-i,y-i),Position(x+i,y+i),Red,false);
	if(i>1.2)
	  anywindow.RenderEllipse(Position(x-i+1.2,y-i+1.2),Position(x+i-1.2,y+i-1.2),White,false);
	delay(50);
	}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,y,1.2,trnnet,trnpts);
	counter_tank++;
	}
}


void Arrow(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float theta=phi*3.141592/180;
	float x=x_fp, y=y_fp,t; float tan,sine,cosine; float xhead=x_fp+.8*cos(theta), yhead= y_fp+0.8*sin(theta);
	
	for(t=0;1;t+=0.01){
	anywindow.RenderLine(Position(x,y),Position(xhead,yhead),White,0.1);
	x=x_fp+0.15*power*cos(theta)*t+0.5*.023*wind*t*t;
	y=y_fp-0.15*power*sin(theta)*t+2*t*t;
	tan=(-0.15*power*sin(theta)+3.8*t)/(0.15*power*cos(theta)+.02*wind*t);
	cosine=(0.15*power*cos(theta)+.02*wind*t)>=0?1/(sqrt(1+tan*tan)):-1/(sqrt(1+tan*tan)); sine=cosine*tan;
	xhead=x+0.8*cosine;
	yhead=y+0.8*sine;
	anywindow.RenderLine(Position(x,y),Position(xhead,yhead),Black,0.1);
	if(yhead>=terrainshape(xhead,trnnet) || ((xhead-tank2x-0.5)*(xhead-tank2x+0.5)<=0 && yhead>=terrainshape(xhead,trnnet)-0.7)){break;}
	delay(10);
	}

	for(float i=0.1; i<2.0; i+=0.1){
	if(i<1.3)
		anywindow.RenderEllipse(Position(xhead-i,yhead-i),Position(xhead+i,yhead+i),Blue,false);
	if(i>0.7)
	  anywindow.RenderEllipse(Position(xhead-i+0.7,yhead-i+0.7),Position(xhead+i-0.7,yhead+i-0.7),White,false);
	delay(100);
	}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,terrainshape(x,trnnet),1.2,trnnet,trnpts);
	counter_tank++;
}


void Cruiser(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,t,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	for(t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-0.3){break;}
		delay(10);
	}

int sign;
sign=(0.15*power*cos(theta)+0.02*wind*t)>=0?-1:1;
if(x>tank2x-0.5){
	while(1){
	nuke.Erase();
	x=x+(0.2*sign);
	Position nukeposition=Position(x,terrainshape(x,trnnet)-0.3);
	nuke.SetPosition(nukeposition);
	nuke.Draw();
	if(x<=tank2x+0.5){break;}
	delay(50);
	}
}
else{
while(1){
nuke.Erase();
x+=0.2*sign;
Position nukeposition=Position(x,terrainshape(x,trnnet)-0.3);
nuke.SetPosition(nukeposition);
nuke.Draw();
if(x>=tank2x-0.5 || x<=tank1x+0.5){break;}
delay(50);
}	
}
	for(float i=0.1; i<3.3; i+=0.1){
	if(i<1.7)
		anywindow.RenderEllipse(Position(x-i,terrainshape(x,trnnet)-i),Position(x+i,terrainshape(x,trnnet)+i),Red,false);
	if(i>1.6)
	  anywindow.RenderEllipse(Position(x-i+1.6,terrainshape(x,trnnet)-i+1.6),Position(x+i-1.6,terrainshape(x,trnnet)+i-1.6),White,false);
	delay(100);
	}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,terrainshape(x,trnnet),1.6,trnnet,trnpts);
	counter_tank++;
}

void Homing_missile(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,t,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	for(t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-0.3 || x>=tank2x){break;}
		delay(10);
	}
	if(x>=tank2x){
		for(t=0;t<10000;t+=0.005){
		nuke.Erase();
		y+=2*t*t;
		Position nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-1){break;}
		delay(50);
		}
	}

	for(float i=0.1; i<3.3; i+=0.1){
	if(i<1.7)
		anywindow.RenderEllipse(Position(x-i,y-i),Position(x+i,y+i),Red,false);
	if(i>1.6)
	  anywindow.RenderEllipse(Position(x-i+1.6,y-i+1.6),Position(x+i-1.6,y+i-1.6),White,false);
	delay(100);
	}
	anywindow.RenderPolygon(trnpts,59,White,false);
	editterrain(x,terrainshape(x,trnnet),1.6,trnnet,trnpts);
}

void Acidrain(float x_fp, float y_fp, int phi, int power, int wind, float trnnet[],Position trnpts[]){
	float x,y,theta;
	BitMap nuke(anywindow);
	nuke.Load("nuke.xpm");
	assert(nuke.GetStatus()==BitMapOkay);
	Position nukeposition=Position(x_fp,y_fp);
	nuke.SetPosition(nukeposition);
	nuke.Draw();

	theta=phi*3.141592/180;
	for(float t=0;1;t+=0.01){
		nuke.Erase();
		x=x_fp+0.15*power*cos(theta)*t+0.5*.02*wind*t*t;
		y=y_fp-0.15*power*sin(theta)*t+2*t*t;
		nukeposition=Position(x,y);
		nuke.SetPosition(nukeposition);
		nuke.Draw();
		if(y>=terrainshape(x,trnnet)-0.5){break;}
		delay(10);
	}
	nuke.Erase();

	BitMap cloud(anywindow);
	cloud.Load("cloud.xpm");
	assert(cloud.GetStatus()==BitMapOkay);
	Position cloudposition=Position(x,y);
	cloud.SetPosition(cloudposition);
	cloud.Draw();

	x_fp=x; y_fp=y-0.3;
	theta=phi*3.141592/180;
	for(float t=0;1;t+=0.01){
		cloud.Erase();
		x=x_fp+0.5*.01*wind*t*t;
		y=y_fp-2*t;
		cloudposition=Position(x,y);
		cloud.SetPosition(cloudposition);
		cloud.Draw();
		if(y<=y_fp-4){break;}
		delay(10);
	}
	int i=0,j=0,count; float xr=x,yr=y+0.5,t;
	while(j<6){	count=0;
		for(t=0;t<3;t+=0.1){
		while(i<6){
		if(yr>=terrainshape(xr,trnnet)-0.5){i++; continue;}
		anywindow.RenderLine(Position(xr,yr), Position(xr+.0015*wind,yr+0.3), White, 0.0);
		xr+=0.15; i++;
		}if(count==6){break;}
		xr=x+.01*wind*t*t; yr=y+0.5+2*t*t; i=0;
		while(i<6){
		if(yr>=terrainshape(xr,trnnet)-0.5){i++; count++; continue;}
		anywindow.RenderLine(Position(xr,yr), Position(xr+.0015*wind,yr+0.3), Cyan, 0.0);
		xr+=0.15; i++;
		}if(count==6){break;}
		xr=x+.01*wind*t*t; yr=y+0.5+2*t*t; i=0;
	delay(50);
}j++;
}cloud.Erase();
}

int ApiMain(){

float trnrand[59],trnstd[59],trnnet[59];
Position trnpts[59];
float angle;
float m,a,x=0,y=0;
int trn; char c;
int power,wind;

srand((unsigned int) time(0));
wind=(-100)+rand()%201;

cout<<"give terrain:(enter 1/2/3 resp. for hill/valley/flat)\n"; cin>>trn;
if(trn==1){
m=0.55+0.01*(rand()%21); a=18;
}
if(trn==2){
m=(-0.7)-0.01*(rand()%21); a=3;
}
if(trn==3){
m=0; a=15;
}

int i=0; float float_i=0;
while(i<57){
float_i=i;
trnrand[i]=0.01*(rand()%51);
trnstd[i]=f(m,a,float_i/2);
trnnet[i]=trnrand[i]+trnstd[i];
trnpts[i]=Position(float_i/2,trnnet[i]);
i++;
}
trnpts[57]=Position(28,21);
trnpts[58]=Position(0,21);

cout<<"press any letter\n"; cin>>c;
anywindow.Open();
assert(anywindow.GetStatus()==WindowOpen);
anywindow.RenderPolygon(trnpts,59,Green,false);
drawtank(tank1x, Blue, trnnet);
drawtank(tank2x, Black, trnnet);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Acidrain(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Wall(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Meteor_shower(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power-7, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Nuke(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Skipper(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Arrow(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Cruiser(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Homing_missile(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);

cout<<"wind:"<<wind<<endl;
cout<<"power:\n"; cin>>power;
cout<<"angle:\n"; cin>>angle;
cout<<"press any letter\n"; cin>>c;
Zapper(tankx, terrainshape(tankx,trnnet)-0.7 , angle, power, wind, trnnet,trnpts);


return 0;
}
